#!/usr/bin/env ruby

input  = ARGV[0] || "SBground.sig"
output = ARGV[1] || "shiftSBground.sig"

target=100 # ms
threshold=0.2 # PSF

t_shift=-10001.0
lines=IO.readlines(input)

puts lines.shift # to remove the line with the number of points

(lines.length-1).times do |line_number|
  col=lines[line_number  ].split; t0 = col[0].to_f; p0 = col[1].to_f
  col=lines[line_number+1].split; t1 = col[0].to_f; p1 = col[1].to_f
  if ( p0<=threshold && threshold<=p1 ) then
    s = (threshold-p0)/(p1-p0)
    t_shift = target - (t0 + s*(t1-t0))
    break
  end
end

raise "threshold not found" if ( t_shift < -10000.0 )

File.open(output,'w') do |o|
  lines.each do |line|
    col=line.split
    t = col[0].to_f
    p = col[1].to_f
    o.puts "#{t+t_shift} #{p}"
  end
end

